import request from '@/utils/request';
import type { ApiResult, PageResult } from '@/api/index';
import type { GoodsRelation, GoodsRelationParam } from './model';
import { MODULES_API_URL } from '@/config/setting';

/**
 * 分页查询商品点赞和收藏表
 */
export async function pageGoodsRelation(params: GoodsRelationParam) {
  const res = await request.get<ApiResult<PageResult<GoodsRelation>>>(
    MODULES_API_URL + '/shop/goods-relation/page',
    {
      params
    }
  );
  if (res.data.code === 0) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 查询商品点赞和收藏表列表
 */
export async function listGoodsRelation(params?: GoodsRelationParam) {
  const res = await request.get<ApiResult<GoodsRelation[]>>(
    MODULES_API_URL + '/shop/goods-relation',
    {
      params
    }
  );
  if (res.data.code === 0 && res.data.data) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 添加商品点赞和收藏表
 */
export async function addGoodsRelation(data: GoodsRelation) {
  const res = await request.post<ApiResult<unknown>>(
    MODULES_API_URL + '/shop/goods-relation',
    data
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 修改商品点赞和收藏表
 */
export async function updateGoodsRelation(data: GoodsRelation) {
  const res = await request.put<ApiResult<unknown>>(
    MODULES_API_URL + '/shop/goods-relation',
    data
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 删除商品点赞和收藏表
 */
export async function removeGoodsRelation(id?: number) {
  const res = await request.delete<ApiResult<unknown>>(
    MODULES_API_URL + '/shop/goods-relation/' + id
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 批量删除商品点赞和收藏表
 */
export async function removeBatchGoodsRelation(data: (number | undefined)[]) {
  const res = await request.delete<ApiResult<unknown>>(
    MODULES_API_URL + '/shop/goods-relation/batch',
    {
      data
    }
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 根据id查询商品点赞和收藏表
 */
export async function getGoodsRelation(id: number) {
  const res = await request.get<ApiResult<GoodsRelation>>(
    MODULES_API_URL + '/shop/goods-relation/' + id
  );
  if (res.data.code === 0 && res.data.data) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}
